/* This file is part of smap.
   Copyright (C) 2006, 2007, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <string.h>
#include "smap/ostr.h"
#include "smap/diag.h"

size_t smap_mapstr_debug_idx = (size_t)-1;

static void
map_flush(void *data, char *buf)
{
	size_t len = strlen(buf);
	FILE *fp = data;
	
	fprintf(fp, "%lu:%s,", (unsigned long) len, buf);
	if (smap_debug_np(smap_mapstr_debug_idx, 10))
		smap_ostream_printf(smap_debug_str, "send: %lu:%s,\n",
				    (unsigned long) len, buf);
	if (smap_trace_str)
		smap_ostream_printf(smap_trace_str, "%s\n", buf);
}

smap_ostream_t
smap_map_ostream_create(FILE *fp)
{
	return smap_ostream_create(map_flush, fp);
}
